/* CORRSCALE - Program to find correlation-based scaling factors for inputs */

#include <stdio.h>
#include <math.h>

static double p[1000], t[1001];

main(int argc, char **argv)
{
  double max;
  int n, i;
  FILE *in;

  if (argc!=3 || (n = atoi(argv[2]))<=0)
  { fprintf(stderr,"Usage: corrscale input-file n-inputs\n");
    exit(1);
  }

  if (n>1000)
  { fprintf(stderr,"corrscale: Too many inputs (max 1000)\n");
    exit(1);
  }

  in = fopen(argv[1],"r");
  if (in==NULL)
  { fprintf(stderr,"corrscale: Can't open input file: %s\n",argv[1]);
    exit(1);
  }

  for (;;)
  {
    for (i = 0; i<n+1; i++)
    { if (fscanf(in,"%lf",&t[i])!=1) break;
    }

    if (i!=n+1) 
    { if (i==0 && feof(in)) 
      { break;
      }
      else
      { fprintf(stderr,"corrscale: Something wrong with the input\n");
        exit(1);
      }
    }

    for (i = 0; i<n; i++)
    { p[i] += t[i]*t[n];
    }
  }

  for (i = 0; i<n; i++)  
  { if (i==0 || p[i]*p[i]>max)
    { max = p[i]*p[i];
    }
  }

  for (i = 0; i<n; i++)
  { printf("x%.6f\n", p[i]*p[i]/max>0.01 ? p[i]*p[i]/max : 0.01);
  }

  exit(0);
}
